<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class ADVKeyIndexList extends \Google\Protobuf\Internal\Message
{
    


    protected $rawId = null;
    


    protected $timestamp = null;
    


    protected $currentIndex = null;
    


    private $validIndexes;
    


    protected $accountType = null;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getRawId()
    {
        return isset($this->rawId) ? $this->rawId : 0;
    }

    public function hasRawId()
    {
        return isset($this->rawId);
    }

    public function clearRawId()
    {
        unset($this->rawId);
    }

    




    public function setRawId($var)
    {
        GPBUtil::checkUint32($var);
        $this->rawId = $var;

        return $this;
    }

    



    public function getTimestamp()
    {
        return isset($this->timestamp) ? $this->timestamp : 0;
    }

    public function hasTimestamp()
    {
        return isset($this->timestamp);
    }

    public function clearTimestamp()
    {
        unset($this->timestamp);
    }

    




    public function setTimestamp($var)
    {
        GPBUtil::checkUint64($var);
        $this->timestamp = $var;

        return $this;
    }

    



    public function getCurrentIndex()
    {
        return isset($this->currentIndex) ? $this->currentIndex : 0;
    }

    public function hasCurrentIndex()
    {
        return isset($this->currentIndex);
    }

    public function clearCurrentIndex()
    {
        unset($this->currentIndex);
    }

    




    public function setCurrentIndex($var)
    {
        GPBUtil::checkUint32($var);
        $this->currentIndex = $var;

        return $this;
    }

    



    public function getValidIndexes()
    {
        return $this->validIndexes;
    }

    




    public function setValidIndexes($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::UINT32);
        $this->validIndexes = $arr;

        return $this;
    }

    



    public function getAccountType()
    {
        return isset($this->accountType) ? $this->accountType : 0;
    }

    public function hasAccountType()
    {
        return isset($this->accountType);
    }

    public function clearAccountType()
    {
        unset($this->accountType);
    }

    




    public function setAccountType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\ADVEncryptionType::class);
        $this->accountType = $var;

        return $this;
    }

}

